/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosclien.h                               1996 SOS GmbH Berlin

#ifndef __SOSCLIEN_H
#define __SOSCLIEN_H

#if !defined __SOSSTRNG_H
#   include "sosstrng.h"
#endif

#if !defined __SOSOBJ_H
//#   include <sosobj.h>
#endif

#if !defined __SOSARRAY_H
#   include "sosarray.h"
#endif

namespace sos
{

struct Sos_database_session;

void init_std_client();
// Trgt Standard-Client in Sos_static ein.

//------------------------------------------------------------------------------------Sos_client

struct Sos_client : Sos_self_deleting
{
                                Sos_client              ();
                               ~Sos_client              ();

    void                        close                   ();

    void                       _obj_print               ( std::ostream* ) const;

    Sos_string                 _name;
    Sos_simple_array< Sos_static_ptr<Sos_database_session> > _session_array;
};


} //namespace sos

#endif
